package com.github.alastair.android.widget;

import android.app.PendingIntent;
import android.app.Service;
import android.appwidget.AppWidgetManager;
import android.appwidget.AppWidgetProvider;
import android.content.Context;
import android.content.Intent;
import android.os.IBinder;
import android.util.Log;
import android.widget.RemoteViews;

public class SampleWidgetProvider extends AppWidgetProvider {

	private final static String TAG = "SampleWidget";
	
	public void onUpdate(Context context, AppWidgetManager appWidgetManager, int[] appWidgetIds) {
		Count.i++;
		// For each loaded widget
		for (int i : appWidgetIds) {
			Log.d(TAG, "Updating to " + Count.i);

			RemoteViews views = new RemoteViews(context.getPackageName(), R.layout.main);
	        views.setTextViewText(R.id.textpos, ""+Count.i);
	        views.setTextColor(R.id.textpos, R.color.black);
	        
	        Intent defineIntent = new Intent(context, ResetIntent.class);
	        PendingIntent pendingIntent = PendingIntent.getService(context,
	                0 /* no requestCode */, defineIntent, 0 /* no flags */);
	        views.setOnClickPendingIntent(R.id.layout, pendingIntent);
	        
	        // Tell the widget manager
	        appWidgetManager.updateAppWidget(i, views);
		}
	}
	
	private static class Count {
		public static int i = 0;
	}
	
	public static class ResetIntent extends Service  {

		public void onStart(Intent intent, int startId) {
			Count.i = 0;
			Log.d(TAG+"/intent", "now set to 0: " + Count.i);
		}
		
		@Override
		public IBinder onBind(Intent intent) {
			return null;
		}
	}
}
